//-----------------------------------------------------------------------------+
#property copyright "Copyright  2010, Trishkin Artyom A."
#property link      "support@goldsuccess.ru"
//-----------------------------------------------------------------------------+
#include <stdlib.mqh>
#include <stderror.mqh>
#include <WinUser32.mqh>
//==============================================================================
// ---------------------------   ---------------------------+
//==============================================================================
extern string  P_Expert= "-- Experts Variables --";
extern double Lots=0.1;                                        // 
extern bool   UseEquClose=true;                                //   -    true = , false = 
extern bool   UseBalanceClose=true;                            //   -    true = , false = 
extern double PercentBalanceForClose=50.0;                     //       
extern double PercentEquityForClose=50.0;                      //       
extern int    NumberLossPoseForClose=5;                        //    
extern int    DistanceSetOrder=10;                             //     
extern int    NumberUpLevels=5;                                //    
extern int    NumberDnLevels=5;                                //    
//-------     ------------------------------+
extern string P_Performanc= "-- Parameters for Trades --";
extern int    NumberOfTry = 5;                                 //     
extern int    Slippage    = 3;                                 //   
extern bool   UseSound    = True;                              //   
string        SoundSuccess= "ok.wav";                          //  
string        SoundError  = "timeout.wav";                     //  
string        SoundClose  = "Close_order.wav";                 //  
//==============================================================================
int      tf, dg, sp;
int      Magic, Level_old, Level_new;
int      MassUpLen, MassDnLen;
string   Prefix, Exp_Name, NameGL_Equ, NameGL_Add, NameGL_Bln, NameGL_BAdd, sy;
color    clUP, clDN;
double   EquStart, EquAdd, EquClose, BlnStart, BlnAdd, BlnClose;
double   CenterLevel, PointX;
double   pa, pb;
double   MassUpLev[5][2];
double   MassDnLev[5][2];
double   MassCtLev[1][2];
double   HighestLev;
double   LowestLev;
//==============================================================================
//----------------------   --------------------------------+
//==============================================================================
bool   AllMessages, PrintEnable;
color  clOpenBuy    = MediumBlue;      //    
color  clOpenSell   = OrangeRed;       //    
color  clCloseBuy   = Blue;            //    
color  clCloseSell  = IndianRed;       //    
color  clModifyBuy  = DodgerBlue;      //    
color  clModifySell = Tomato;          //    
color  clDelete     = Yellow;          //    
bool   MarketWatch  = True;            //    "Market Watch".
bool   gbDisabled   = False;           //   
int    modeSetOrders= 1;               //   :
                                       //  0 -   
                                       //  1 -  
                                       //  2 -    
//----------------------------------------------------------------
//==============================================================================
int init()
{
   double p1, p2;
   tf=Period();
   sy=Symbol();
   pa=MarketInfo(sy,MODE_ASK);
   pb=MarketInfo(sy,MODE_BID);
   dg=MarketInfo(sy,MODE_DIGITS);
   Level_old=MarketInfo(Symbol(),MODE_STOPLEVEL );             // .   
   if(Digits==5 || Digits==3) PointX = Point * 10;             //  Point  - 
   if(Digits==4 || Digits==2) PointX = Point;
   Exp_Name=WindowExpertName();                                //  
   Prefix=Exp_Name+"_M"+Period();                              //    
   Magic=GetMagic(Exp_Name+Symbol(),Period());                 //  
   NameGL_Equ=Prefix+"_GL_Equ";
   NameGL_Add=Prefix+"_GL_Add";
   NameGL_Bln=Prefix+"_GL_Bln";
   NameGL_BAdd=Prefix+"_GL_BAdd";
   if(!GlobalVariableCheck(NameGL_Equ)) {                      //        NameGL_Equ
      EquStart=AccountEquity();                                //   = 
      EquAdd=NormalizeDouble(EquStart/100*PercentEquityForClose,dg); //   ,       
      BlnStart=AccountBalance();
      BlnAdd=NormalizeDouble(BlnStart/100*PercentBalanceForClose,dg);
      GlobalVariableSet(NameGL_Equ,EquStart);                  //         
      GlobalVariableSet(NameGL_Add,EquAdd);
      GlobalVariableSet(NameGL_Bln,BlnStart);                  //         
      GlobalVariableSet(NameGL_BAdd,BlnAdd);
      }
   else {
      EquStart=GlobalVariableGet(NameGL_Equ);       //     ,    =   
      EquAdd=GlobalVariableGet(NameGL_Add);
      BlnStart=GlobalVariableGet(NameGL_Bln);       //     ,    =   
      BlnAdd=GlobalVariableGet(NameGL_BAdd);
      }
   p1=GlobalVariableGet(NameGL_Equ);
   p2=GlobalVariableGet(NameGL_Add);
   EquClose=NormalizeDouble(p1+p2,dg);
   p1=GlobalVariableGet(NameGL_Bln);
   p2=GlobalVariableGet(NameGL_BAdd);
   BlnClose=NormalizeDouble(p1+p2,dg);
   if (PercentEquityForClose<=0)  PercentEquityForClose=PointX;
   if (PercentBalanceForClose<=0) PercentBalanceForClose=PointX;
   if (NumberLossPoseForClose<=0) NumberLossPoseForClose=1;
   if (DistanceSetOrder<=0)       DistanceSetOrder=Level_old+1;
//==============================================================================
// -------------       ----------------+
//==============================================================================
   if (NumberUpLevels<2) NumberUpLevels=2;
   if (NumberDnLevels<2) NumberDnLevels=2;
   ArrayResize(MassUpLev, NumberUpLevels);                     //    ...
   ArrayResize(MassDnLev, NumberDnLevels);                     // ...   
   ArrayInitialize(MassCtLev, 0);                              //   
   ArrayInitialize(MassUpLev, 0);                              //   
   ArrayInitialize(MassDnLev, 0);                              //   
   CenterLevel=pa;
   MassCtLev[0][0]=CenterLevel;
   SetLevels();
   return(0);
}
//==============================================================================
int deinit()                              // .  deinit()
{
// --------    ,     --------
   string Name_Del[1]; 
   int Quant_Del=0;                    
   int Quant_Objects=ObjectsTotal();   
   int LenPref=StringLen(Prefix);
   ArrayResize(Name_Del,Quant_Objects);
   for(int k=0; k<Quant_Objects; k++) {
         string Obj_Name=ObjectName(k);   
         string Head=StringSubstr(Obj_Name,0,LenPref);
         if (Head==Prefix) {                              
               Quant_Del+=1;        
               Name_Del[Quant_Del-1]=Obj_Name;
            }
     }
   for(int i=0; i<Quant_Del; i++)    
      ObjectDelete(Name_Del[i]); 
// -----     ,     -----
   if (!IsTesting()) Comment("");                                 //   (  )
   else if (IsTesting())                                          //   ,  ...
      if(GlobalVariableCheck(NameGL_Equ)) {                       // ...        NameGL_Equ ...
         GlobalVariableDel(NameGL_Equ);                           // ...  
         GlobalVariableDel(NameGL_Add);
         }
   return;                                                        //   deinit()
}
//==============================================================================
int start()
{
   int i;
   double p1, p2;
   tf=Period();
   sy=Symbol();
   pa=MarketInfo(sy,MODE_ASK);
   pb=MarketInfo(sy,MODE_BID);
   sp=MarketInfo(sy,MODE_SPREAD);
   Level_new=MarketInfo(sy,MODE_STOPLEVEL );                      //      
   if (Level_old!=Level_new) {                                    //    ,   
      Level_old=Level_new;                                        //  " "
      if (DistanceSetOrder<=Level_new)       DistanceSetOrder=Level_new+1;
      }
   p1=GlobalVariableGet(NameGL_Equ);
   p2=GlobalVariableGet(NameGL_Add);
   EquClose=NormalizeDouble(p1+p2,dg);
   if (UseEquClose)
   if (AccountEquity()>=EquClose) {
      CloseLoss(NumberLossPoseForClose);
      EquStart=AccountEquity();
      GlobalVariableSet(NameGL_Equ,EquStart);
      }
   p1=GlobalVariableGet(NameGL_Bln);
   p2=GlobalVariableGet(NameGL_BAdd);
   BlnClose=NormalizeDouble(p1+p2,dg);
   if (UseBalanceClose)
   if (AccountBalance()>=BlnClose) {
      int NumberLossPose=0;
      double pr=0;
      for (i=0; i<OrdersTotal(); i++) {
         if (OrderSelect(i,SELECT_BY_POS)) {
            if (OrderMagicNumber()!=Magic)   continue;
            if (OrderSymbol()!=sy)           continue;
            if (OrderType()>1)               continue;
            if (OrderProfit()+OrderSwap()<pr) 
               ClosePosWithMaxLossInCurrency(sy, Magic);
            }
         }
      BlnStart=AccountBalance();
      BlnAdd=NormalizeDouble(BlnStart/100*PercentBalanceForClose,dg);
      GlobalVariableSet(NameGL_Bln,BlnStart);
      GlobalVariableSet(NameGL_BAdd,BlnAdd);
      }
//==============================================================================
// -------------------   StopLevel   --------------------+
//==============================================================================
   color cl=FireBrick;
   string RectUP=Prefix+"_RectUp_StLevel";
   double pUP1=pa;
   double pUP2=NormalizeDouble(pa+Level_new*PointX,dg);
   SetRectangle(cl, RectUP, Time[3], pUP1, Time[0]+3*Period()*60, pUP2);
   string RectDN=Prefix+"_RectDn_StLevel";
   double pDN1=pb;
   double pDN2=NormalizeDouble(pb-Level_new*PointX,dg);
   SetRectangle(cl, RectDN, Time[3], pDN1, Time[0]+3*Period()*60, pDN2);
//==============================================================================
// -----------------     -------------------+
//==============================================================================
   if (pa>NormalizeDouble(CenterLevel+DistanceSetOrder*PointX,dg)) {
      CenterLevel=NormalizeDouble(CenterLevel+DistanceSetOrder*PointX,dg);
      MassCtLev[0][0]=CenterLevel;
      SetLevels();
      }
   if (pb<NormalizeDouble(CenterLevel-DistanceSetOrder*PointX,dg)) {
      CenterLevel=NormalizeDouble(CenterLevel-DistanceSetOrder*PointX,dg);
      MassCtLev[0][0]=CenterLevel;
      SetLevels();
      }
//==============================================================================
// -----------------     -------------------+
//==============================================================================
   if (!ExistOrdersByPrice(Symbol(), -1, Magic, MassCtLev[0][0])) SetOrders(0, 0);
   for (i=0; i<MassUpLen; i++) {
      if (!ExistOrdersByPrice(Symbol(), -1, Magic, MassUpLev[i][0])) SetOrders(i, +1);
      }
   for (i=0; i<MassDnLen; i++) {
      if (!ExistOrdersByPrice(Symbol(), -1, Magic, MassDnLev[i][0])) SetOrders(i, -1);
      }
   informations();

   return(0);  // --------------------   start() -----------------------+
}

//==============================================================================
// ---------------------------------  ----------------------------------+
//==============================================================================
//==============================================================================
// ----------------------------   -----------------------------+
//==============================================================================
double SetOrders(int Lev, int Direction) {
   double Level, pp, tp, Res, sslev=NormalizeDouble((Level_new+sp)*PointX,dg);
   string co;
   if (Direction==0) {                                               //    
      if (NormalizeDouble(pa-MassCtLev[0][0],dg)>sslev) {            //  Ask     +, ...
         co=Prefix+"_BuyLimit_";
         pp=NormalizeDouble(MassCtLev[0][0],dg);
         tp=NormalizeDouble(pp+DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_BUYLIMIT, Lots, pp, 0, tp, Magic, co);
         Res=pp;
         co=Prefix+"_SellStop_";
         pp=NormalizeDouble(MassCtLev[0][0]-sp*PointX,dg);
         tp=NormalizeDouble(pp-DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_SELLSTOP, Lots, pp, 0, tp, Magic, co);
         }
      if (NormalizeDouble(MassCtLev[0][0]-pa,dg)>sslev) {            //  Ask     +, ...
         co=Prefix+"_BuyStop_";
         pp=NormalizeDouble(MassCtLev[0][0],dg);
         tp=NormalizeDouble(pp+DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_BUYSTOP, Lots, pp, 0, tp, Magic, co);
         Res=pp;
         co=Prefix+"_SellLimit_";
         pp=NormalizeDouble(MassCtLev[0][0]-sp*PointX,dg);
         tp=NormalizeDouble(pp-DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_SELLLIMIT, Lots, pp, 0, tp, Magic, co);
         }
      }
   if (Direction>0) {                                                //    
      if (NormalizeDouble(pa-MassUpLev[Lev][0],dg)>sslev) {          //  Ask     +, ...
         co=Prefix+"_BuyLimit__"+Lev;
         pp=NormalizeDouble(MassUpLev[Lev][0],dg);
         tp=NormalizeDouble(pp+DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_BUYLIMIT, Lots, pp, 0, tp, Magic, co);
         Res=pp;
         co=Prefix+"_SellStop__"+Lev;
         pp=NormalizeDouble(MassUpLev[Lev][0]-sp*PointX,dg);
         tp=NormalizeDouble(pp-DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_SELLSTOP, Lots, pp, 0, tp, Magic, co);
         }
      if (NormalizeDouble(MassUpLev[Lev][0]-pa,dg)>sslev) {          //  Ask     +, ...
         co=Prefix+"_BuyStop__"+Lev;
         pp=NormalizeDouble(MassUpLev[Lev][0],dg);
         tp=NormalizeDouble(pp+DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_BUYSTOP, Lots, pp, 0, tp, Magic, co);
         Res=pp;
         co=Prefix+"_SellLimit__"+Lev;
         pp=NormalizeDouble(MassUpLev[Lev][0]-sp*PointX,dg);
         tp=NormalizeDouble(pp-DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_SELLLIMIT, Lots, pp, 0, tp, Magic, co);
         }
      }
   if (Direction<0) {                                                //    
      if (NormalizeDouble(pa-MassDnLev[Lev][0],dg)>sslev) {          //  Ask     +, ...
         co=Prefix+"_BuyLimit__"+Lev;
         pp=NormalizeDouble(MassDnLev[Lev][0],dg);
         tp=NormalizeDouble(pp+DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_BUYLIMIT, Lots, pp, 0, tp, Magic, co);
         Res=pp;
         co=Prefix+"_SellStop__"+Lev;
         pp=NormalizeDouble(MassDnLev[Lev][0]-sp*PointX,dg);
         tp=NormalizeDouble(pp-DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_SELLSTOP, Lots, pp, 0, tp, Magic, co);
         }
      if (NormalizeDouble(MassDnLev[Lev][0]-pa,dg)>sslev) {          //  Ask     +, ...
         co=Prefix+"_BuyStop__"+Lev;
         pp=NormalizeDouble(MassDnLev[Lev][0],dg);
         tp=NormalizeDouble(pp+DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_BUYSTOP, Lots, pp, 0, tp, Magic, co);
         Res=pp;
         co=Prefix+"_SellLimit__"+Lev;
         pp=NormalizeDouble(MassDnLev[Lev][0]-sp*PointX,dg);
         tp=NormalizeDouble(pp-DistanceSetOrder*PointX,dg);
         SetOrder(sy, OP_SELLLIMIT, Lots, pp, 0, tp, Magic, co);
         }
      }
   return(Res);
}
//+----------------------------------------------------------------------------+
void SetLevels() {
   int i;
   double step, lev;
   MassCtLev[0][0]=CenterLevel;
   string NameLevelCT=Prefix+"_CenterLevel_";                  //   
   SetArrow(4, MediumSpringGreen, NameLevelCT, Time[0], CenterLevel, 0);
   
   for (i=0; i<NumberUpLevels; i++) {
      step=((i+1)*DistanceSetOrder)*PointX;                    //   
      lev=NormalizeDouble(MassCtLev[0][0]+step,dg);                //   i- 
      MassUpLev[i][0]=lev;                                     //  
// --------------------      -----------------------+
      clUP=DeepSkyBlue;                                        //   
      string NameLevelUP=Prefix+"_UpLevel_"+DoubleToStr(i,0);  //  
      SetArrow(4, clUP, NameLevelUP, Time[0], lev, 0);         //  i-
      }
   for (i=0; i<NumberDnLevels; i++) {
      step=((i+1)*DistanceSetOrder)*PointX;                    //   
      lev=NormalizeDouble(MassCtLev[0][0]-step,dg);                //   i- 
      MassDnLev[i][0]=lev;                                     //  
// --------------------      ------------------------+
      clDN=Gold;                                               //   
      string NameLevelDN=Prefix+"_DnLevel_"+DoubleToStr(i+1,0);//  
      SetArrow(4, clDN, NameLevelDN, Time[0], lev, 0);         //  
      }
   MassUpLen=ArrayRange(MassUpLev,0);
   MassDnLen=ArrayRange(MassDnLev,0);
   HighestLev=MassUpLev[MassUpLen-1][0];
   LowestLev =MassDnLev[MassDnLen-1][0];
// --------------------     ------------------------+
   bool fd;
   int  it, err;
   for (i=0; i<OrdersTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS)) {
         if (OrderMagicNumber()!=Magic)   continue;
         if (OrderSymbol()!=sy)           continue;
         if (OrderType()>1 && OrderType()<6) {
            if (NormalizeDouble(OrderOpenPrice()-HighestLev+DistanceSetOrder*PointX,dg)>0 ||
                NormalizeDouble(LowestLev-DistanceSetOrder*PointX-OrderOpenPrice(),dg)>0) {
               for (it=1; it<=NumberOfTry; it++) {
                  if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
                  while (!IsTradeAllowed()) Sleep(5000);
                  fd=OrderDelete(OrderTicket(), clDelete);
                  if (fd) {
                     if (UseSound) PlaySound(SoundSuccess); break; 
                        } 
                  else {
                     err=GetLastError();
                     Print("Error(",err,") delete order ",GetNameOP(OrderType()), ": ",ErrorDescription(err),", try ",it);
                     Sleep(1000*5);
                     }
                  }
               }
            }
         }
      }
   return;
}
//+----------------------------------------------------------------------------+
void CloseLoss(int numLoss) {
   for (int i=0; i<numLoss; i++) ClosePosWithMaxLossInCurrency(sy, Magic);
}
//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
void informations() {
   string Text, nmEqu, font;
   color  cl;
   int    angle, xDist, yDist, size;
//+----------------------------------------------------------------------------+
   Text=" : ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_Balance";
   angle=2; xDist=10; yDist=70;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(AccountBalance(),2); //   
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_AccBalance";
   angle=2; xDist=150; yDist=70;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
   Text=" : ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_Equity";
   angle=2; xDist=10; yDist=50;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(AccountEquity(),2); //   
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_AccEquity";
   angle=2; xDist=150; yDist=50;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
   Text=" Buy: ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_LossBuy";
   angle=2; xDist=10; yDist=10;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(NumLossPos(OP_BUY),0);
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_LossBuy";
   angle=2; xDist=150; yDist=10;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
   Text="  : ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_CloseBalance";
   angle=2; xDist=220; yDist=70;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(BlnClose,2); //   
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_ClsBalance";
   angle=2; xDist=350; yDist=70;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
   Text="  : ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_CloseEquity";
   angle=2; xDist=220; yDist=50;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(EquClose,2); //   
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_ClsEquity";
   angle=2; xDist=350; yDist=50;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
   Text=" Sell: ";
   cl=LightBlue;
   nmEqu=Prefix+"_txt_LossSell";
   angle=2; xDist=220; yDist=10;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
   
   Text=DoubleToStr(NumLossPos(OP_SELL),0);
   cl=NavajoWhite;
   nmEqu=Prefix+"_num_LossSell";
   angle=2; xDist=350; yDist=10;
   font="Arial";
   size=10;
   SetText(Text, cl, nmEqu, angle, xDist, yDist, font, size);
//+----------------------------------------------------------------------------+
}
//==============================================================================
// -----------------------------   -----------------------------+
//==============================================================================
void SetOrder(string sy, int op, double ll, double pp,
              double sl=0, double tp=0, int mn=0, string co="", datetime ex=0) {
  color    cl=IIFc(op==OP_BUYLIMIT || op==OP_BUYSTOP, clOpenBuy, clOpenSell);
  datetime ot;
  double   pa, pb, mp;
  int      err, it, ticket, msl;

  if (sy=="" || sy=="0") sy=Symbol();
  msl=MarketInfo(sy, MODE_STOPLEVEL);
  if (co=="") co=WindowExpertName()+" "+GetNameTF(Period());
  if (ex>0 && ex<TimeCurrent()) ex=0;
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("SetOrder():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    ot=TimeCurrent();
    ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, co, mn, ex, cl);
    if (ticket>0) {
      if (UseSound) PlaySound(SoundSuccess); break;
    } else {
      err=GetLastError();
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66);
        if (ExistOrders(sy, op, mn, ot)) {
          if (UseSound) PlaySound(SoundSuccess); break;
        }
        Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
        continue;
      }
      if (UseSound) PlaySound(SoundError);
      mp=MarketInfo(sy, MODE_POINT);
      pa=MarketInfo(sy, MODE_ASK);
      pb=MarketInfo(sy, MODE_BID);
      if (pa==0 && pb==0) Message("SetOrder():       "+sy);
      Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa,"  Bid=",pb,"  sy=",sy,"  ll=",ll,"  op=",GetNameOP(op),
            "  pp=",pp,"  sl=",sl,"  tp=",tp,"  mn=",mn);
      //  
      if (err==130) {
        //   
        if (modeSetOrders==1) {
          Sleep(1000*5.3);
          switch (op) {
            case OP_BUYLIMIT:
              if (pp>pa-msl*mp) pp=pa-msl*mp;
              if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
              if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
              break;
            case OP_BUYSTOP:
              if (pp<pa+(msl+1)*mp) pp=pa+(msl+1)*mp;
              if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
              if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
              break;
            case OP_SELLLIMIT:
              if (pp<pb+msl*mp) pp=pb+msl*mp;
              if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
              if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
              break;
            case OP_SELLSTOP:
              if (pp>pb-msl*mp) pp=pb-msl*mp;
              if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
              if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
              break;
          }
          Print("SetOrder():   ");
          continue;
        }
        //    
        if (modeSetOrders==2) {
          Print("SetOrder():    ");
          if (op==OP_BUYLIMIT || op==OP_BUYSTOP) OpenPosition(sy, OP_BUY, ll, sl, tp, mn, co);
          if (op==OP_SELLLIMIT || op==OP_SELLSTOP) OpenPosition(sy, OP_SELL, ll, sl, tp, mn, co);
          break;
        }
      }
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      //    (8)     (141)
      if (err==8 || err==141) Sleep(1000*100);
      if (err==139 || err==140 || err==148) break;
      //    
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      //   
      if (err==147) {
        ex=0; continue;
      }
      if (err!=135 && err!=138) Sleep(1000*7.7);
    }
  }
}
//+----------------------------------------------------------------------------+
void OpenPosition(string sy, int op, double ll, double sl=0, double tp=0, int mn=0, string co="") {
  color    clOpen;
  datetime ot;
  double   pp, pa, pb;
  int      dg, err, it, ticket=0;

  if (sy=="" || sy=="0") sy=Symbol();
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  if (co=="") co=WindowExpertName()+" "+GetNameTF(Period());
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("OpenPosition(): Function stopped");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000); //Sleep_RND(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    ot=TimeCurrent();
    if (MarketWatch)
      ticket=OrderSend(sy, op, ll, pp, Slippage, 0, 0, co, mn, 0, clOpen);
    else
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, co, mn, 0, clOpen);
    if (ticket>0) {
      if (UseSound) PlaySound(SoundSuccess); break;
    } else {
      err=GetLastError();
      if (UseSound) PlaySound(SoundError);
      if (pa==0 && pb==0) Message("Check in the MarketWatch presence of the symbol "+sy);
      //    
      Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
            " pp=",pp," sl=",sl," tp=",tp," mn=",mn);
      //   
      if (err==2  ||                //  
          err==64 ||                //  
          err==65 ||                //   
          err==133)                 //  
          {
        gbDisabled=True; break;     //  
      }
      //  
      if (err==4   ||               //   
          err==131 ||               //  
          err==132)                 //  
          {
        Sleep(1000*300); break; // Sleep_RND(1000*300);
      }
      if (err==128 ||               //     
          err==142 ||               //    
          err==143)                 //     
          {
        Sleep(1000*66.666); // Sleep_RND(1000*66.666);
        if (ExistPositions(sy, op, mn, ot)) {
          if (UseSound) PlaySound(SoundSuccess); break;
        }
      }
      if (err==140  ||              //   
          err==148  ||              //       ,  
          err==4110 ||              //    .    
          err==4111)                //    .    
          break;
      if (err==141) /*Sleep(1000*100);*/ Sleep_RND(1000*100); //   
      if (err==145) /*Sleep(1000*17);*/  Sleep_RND(1000*17);  //  ,       
      if (err==146) while (IsTradeContextBusy()) /*Sleep(1000*11);*/ Sleep_RND(1000*11);  //   
      if (err!=135) /*Sleep(1000*7.7);*/ Sleep_RND(1000*7.7);                             //  
    }
  }
  if (MarketWatch && ticket>0 && (sl>0 || tp>0)) {
    if (OrderSelect(ticket, SELECT_BY_TICKET)) ModifyOrder(-1, sl, tp);
  }
}
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0,color cl=CLR_NONE) {
  bool   fm;
              cl=IIFc(OrderType()==OP_BUY
              || OrderType()==OP_BUYLIMIT
              || OrderType()==OP_BUYSTOP, clModifyBuy, clModifySell);
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      if (fm) {
        if (UseSound) PlaySound(SoundSuccess); break;
      } else {
        er=GetLastError();
        if (UseSound) PlaySound(SoundError);
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
}
//+----------------------------------------------------------------------------+
void ClosePosWithMaxLossInCurrency(string sy="", int mn=-1) {
   double pr=0;
   int    i, k=OrdersTotal(), np=-1;

   for (i=k-1; i>=0; i--) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol()!=sy)        continue;
         if (OrderType()>1)            continue;
         if (OrderMagicNumber()!=mn)   continue;
         if (pr>OrderProfit()+OrderSwap()) {
            pr=OrderProfit()+OrderSwap();
            np=i;
            }
         }
      }
   if (np>=0) {
      if (OrderSelect(np, SELECT_BY_POS, MODE_TRADES)) {
         ClosePosBySelect();
         }
      }
   return;
}
//+----------------------------------------------------------------------------+
void ClosePosBySelect() {
  bool   fc;
  color  clClose;
  double ll, pa, pb, pp;
  int    err, it;

  if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      pa=MarketInfo(OrderSymbol(), MODE_ASK);
      pb=MarketInfo(OrderSymbol(), MODE_BID);
      if (OrderType()==OP_BUY) {
        pp=pb; clClose=clCloseBuy;
      } else {
        pp=pa; clClose=clCloseSell;
      }
      ll=OrderLots();
      fc=OrderClose(OrderTicket(), ll, NormalizeDouble(pp,dg), Slippage, clClose);
      if (fc) {
        if (UseSound) PlaySound(SoundSuccess); break;
      } else {
        err=GetLastError();
        if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
        Print("Error(",err,") Close ",GetNameOP(OrderType())," ",
              ErrorDescription(err),", try ",it);
        Print(OrderTicket(),"  Ask=",pa,"  Bid=",pb,"  pp=",pp);
        Print("sy=",OrderSymbol(),"  ll=",ll,"  sl=",OrderStopLoss(),
              "  tp=",OrderTakeProfit(),"  mn=",OrderMagicNumber());
        Sleep(1000*5);
      }
    }
  } else Print("  . Close ",GetNameOP(OrderType()));
}
//==============================================================================
// -------------------------   --------------------------+
//==============================================================================
void Sleep_RND(int _Pausa)
  {
   MathSrand(TimeLocal());
   MathRand();
   Sleep(MathRound(_Pausa*MathRand()/32767+_Pausa/5));
   return;
  }
//+----------------------------------------------------------------------------+
color IIFc(bool condition, color ifTrue, color ifFalse) {
  if (condition) return(ifTrue); else return(ifFalse);
}
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame=0) {
  if (TimeFrame==0) TimeFrame=Period();
  switch (TimeFrame) {
    case PERIOD_M1:  return("M1");
    case PERIOD_M5:  return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1:  return("H1");
    case PERIOD_H4:  return("H4");
    case PERIOD_D1:  return("Daily");
    case PERIOD_W1:  return("Weekly");
    case PERIOD_MN1: return("Monthly");
    default:         return("UnknownPeriod");
  }
}
//+----------------------------------------------------------------------------+
void Message(string m) 
{
   static string prevMessage="";
   Comment(m);
   if (StringLen(m)>0 && PrintEnable) {
      if (AllMessages || prevMessage!=m) {
         prevMessage=m;
         Print(m);
         }
      }
}
//+----------------------------------------------------------------------------+
string GetNameOP(int op) 
{
   switch (op) {
      case OP_BUY      : return("Buy");
      case OP_SELL     : return("Sell");
      case OP_BUYLIMIT : return("Buy Limit");
      case OP_SELLLIMIT: return("Sell Limit");
      case OP_BUYSTOP  : return("Buy Stop");
      case OP_SELLSTOP : return("Sell Stop");
      default          : return("Unknown Operation");
      }
}
//+----------------------------------------------------------------------------+
int GetMagic(string symbolstring, int multiplier) {
   int res=0;
   int len=StringLen(symbolstring);
   for(int i=0; i<len; i++)
       res+=StringGetChar(symbolstring,i);      
   return(res*multiplier);
}
//==============================================================================
// ------------------------    --------------------------+
//==============================================================================
int NumLossPos(int type) {
   int    numloss=0;
   for (int i=0; i<OrdersTotal(); i++) {
      if (OrderSelect(i, SELECT_BY_POS)) {
         if (OrderType()!=type)           continue;
         if (OrderSymbol()!=sy)           continue;
         if (OrderMagicNumber()!=Magic)   continue;
         if (OrderProfit()+OrderSwap()+OrderCommission()<0) numloss++;
         }
      }
   return(numloss);
}
//+----------------------------------------------------------------------------+
bool ExistOrders(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal(), ty;
 
  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ty=OrderType();
      if (ty>1 && ty<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ty==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (ot<=OrderOpenTime()) return(True);
          }
        }
      }
    }
  }
  return(False);
}
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) 
{
   int i, k=OrdersTotal();
   if (sy=="0") sy=Symbol();
   for (i=0; i<k; i++) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol()!=sy)        continue;
         if (OrderType()!=op)          continue;
         if (OrderMagicNumber()!=mn)   continue;
         if (ot<=OrderOpenTime()) return(True);
         }
      }
  return(False);
}
//+----------------------------------------------------------------------------+
bool ExistOrdersByPrice(string sy="", int op=-1, int mn=-1, double pp=-1) {
   int d, i, k=OrdersTotal();

   for (i=0; i<k; i++) {
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         if (OrderSymbol()!=sy)        continue;
         if (OrderMagicNumber()!=mn)   continue;
         if (OrderType()>=0 && OrderType()<6) {
            d=MarketInfo(OrderSymbol(), MODE_DIGITS);
            pp=NormalizeDouble(pp, d);
            if (pp==NormalizeDouble(OrderOpenPrice(), d)) return(True);
            }
         }
      }
   return(False);
}
//==============================================================================
// ---------------------------   ----------------------------+
//==============================================================================
void SetArrow(int cd, color cl, string nm="", datetime t1=0, double p1=0, int sz=0) {
   if (nm=="") nm=DoubleToStr(Time[0], 0);
   if (t1<=0) t1=Time[0];
   if (p1<=0) p1=Bid;
   if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_ARROW, 0, 0, 0);
   ObjectSet(nm, OBJPROP_TIME1    , t1);
   ObjectSet(nm, OBJPROP_PRICE1   , p1);
   ObjectSet(nm, OBJPROP_ARROWCODE, cd);
   ObjectSet(nm, OBJPROP_COLOR    , cl);
   ObjectSet(nm, OBJPROP_WIDTH    , sz);
}
//+----------------------------------------------------------------------------+
void SetRectangle(color cl, string nm="", datetime t1=0, double p1=0, datetime t2=0, double p2=0, int sz=0) {
   if (nm=="") nm=DoubleToStr(Time[0], 0);
   if (t1<=0) t1=Time[10];
   if (p1<=0) p1=Ask;
   if (t2<=0) t2=Time[0];
   if (p2<=0) p2=Ask+Level_new*PointX;
   if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_RECTANGLE, 0, 0, 0, 0, 0);
   ObjectSet(nm, OBJPROP_TIME1    , t1);
   ObjectSet(nm, OBJPROP_PRICE1   , p1);
   ObjectSet(nm, OBJPROP_TIME2    , t2);
   ObjectSet(nm, OBJPROP_PRICE2   , p2);
   ObjectSet(nm, OBJPROP_COLOR    , cl);
   ObjectSet(nm, OBJPROP_WIDTH    , sz);
}
//+----------------------------------------------------------------------------+
void SetText(string Text, color cl, string nm, int angle, int x, int y, string font, int sz=0) {
   if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, 0, 0, 0);
   ObjectSet(nm, OBJPROP_CORNER   , angle);
   ObjectSet(nm, OBJPROP_XDISTANCE, x);
   ObjectSet(nm, OBJPROP_YDISTANCE, y);
   ObjectSet(nm, OBJPROP_WIDTH    , sz);
   ObjectSetText(nm, Text, sz, font, cl);
   }
//+----------------------------------------------------------------------------+

